// JavaScript Document

// WARNING: using this interface to load plugin
// will _NOT_ work if plugins do not have the language
// loaded by HTMLArea.

// In other words, this function generates SCRIPT tags
// that load the plugin and the language file, based on the
// global variable HTMLArea.I18N.lang (defined in the lang file,
// in our case "lang/en.js" loaded above).

// If this lang file is not found the plugin will fail to
// load correctly and nothing will work.

HTMLArea.loadPlugin("TableOperations");
HTMLArea.loadPlugin("SpellChecker");
HTMLArea.loadPlugin("ContextMenu");
HTMLArea.loadPlugin("ImageManager");
HTMLArea.loadPlugin("ListType");
//dec 2005
HTMLArea.loadPlugin("InsertAnchor");
HTMLArea.loadPlugin("InsertMarquee");


HTMLArea.onload = initEditor; 

var editor = null;

function initEditor() 
{
	editor = new HTMLArea('ta');
	 
	var config = new HTMLArea.Config();
	config.toolbar = 
		[
			[ "fontname", "space",
			  "fontsize", "space",
			  "formatblock", "space",
			  "bold", "italic", "underline", "strikethrough","unformat", "separator",
			  "subscript", "superscript", "separator",
			  "copy", "cut", "paste", "specialpaste","space", "undo", "redo", "separator", 
			  "forecolor", "hilitecolor", "separator",
			  "inserttable", "inserthorizontalrule", "datetime", "separator"],
	
			[ "justifyleft", "justifycenter", "justifyright", "justifyfull", "separator",
			  "lefttoright", "righttoleft", "separator",
			  "orderedlist", "unorderedlist", "outdent", "indent", "separator",
			  "insertwikilink", "createlink", "insertfile", "insertimage", "separator","htmlmode","about"]
		];
	
	//ADDITIONAL BUTTONS DEFINTION
	
	//TEMPORARY (Manual) LANGUAGE DEFINITION (HAVE TO BE PUT IN THE LANGAGE FILE IN THE FUTURE)
		
	
	//var insertfile_caption = "Insrer un fichier";
	var insertfile_caption = "Insert a file";
	//var unformat_caption = "Retirer le formatage";
	var unformat_caption = "Unformat text"
	//var createlink_caption = "Inserer un lien vers un site";
	var createlink_caption = "Insert a Weblink";
	//var specialpaste_caption = "Coller sans format"
	var specialpaste_caption = "Paste without format"
	
	config.registerButton("insertfile", insertfile_caption , "Area/images/ed_linktofile.gif", false,insertFile );
	config.registerButton("unformat", unformat_caption , "Area/images/removeformat.gif", false, function(editor, id) { editor.execCommand('FormatBlock','','Normal'); editor.execCommand('RemoveFormat'); editor.execCommand('unlink');} );
	config.registerButton("createlink", createlink_caption , "Area/images/createlink.gif", false, function(e) {e.execCommand("createlink", true);});
  config.registerButton("specialpaste", specialpaste_caption ,"Area/images/ed_paste.gif",false,
		
		
		
		
		function(editor,id)
		{ 
	       var str = window.clipboardData.getData("Text");
				if (str == null) 
				{
		       		alert('\nClipboard is empty.\n\nNothing to paste!');
		       	 		return;
				}
				else
				{
					editor.execCommand('FormatBlock','','Normal')
					editor.execCommand('RemoveFormat');
					editor.execCommand('unlink');
					//execCommands are necessary in case the user happens to paste some new text to replace selected text.
					var myText = showModalDialog(_editor_url + "/popups/plaintext.html","", "resizable: yes; help: no; status: no; scroll: no; ");
					if (myText) { editor.insertHTML(unescape( myText) );}
				}//end else
		}//end if myText 
	);
	
	//var datetime_caption = "Inserer la date et l'heure";
	var datetime_caption = "Insert date and time";
	//var insertwikilink_caption = "Insrer un lien vers une page du wiki";
	var insertwikilink_caption = "Insert an internal-to-wiki link";
	
	
	config.registerButton("datetime", datetime_caption , "Area/images/date.gif",false, function(e) { e.insertHTML((new Date()).toString()); });
	config.registerButton("insertwikilink", insertwikilink_caption , "Area/images/ed_link-wiki.gif", false,insertWikiLink );
	
	
	
	
	config.baseURL = ''; 

  
	config.killWordOnPaste = true;
	editor.config= config;
	editor._customUndo  = true;

	editor.registerPlugin(TableOperations);
	
	// register the SpellChecker plugin
	//editor.registerPlugin(SpellChecker);
	
	editor.registerPlugin(ImageManager);
	editor.registerPlugin(ListType);
	//dec 2005
	editor.registerPlugin(InsertAnchor);
  editor.registerPlugin(InsertMarquee);//ici bug et met des erreurs
  // add a contextual menu
  editor.registerPlugin("ContextMenu");

  // load the stylesheet used by our CSS plugin configuration
  editor.config.pageStyle = "@import url(wk_style.css);";

  // register the FullPage plugin
  //editor.registerPlugin(FullPage);
	
  // register the SpellChecker plugin
  

  setTimeout(function() {
    editor.generate();if(editorLoaded)editorLoaded();
  }, 500);
  
   return false;
 
}

function insertHTML() {
  var html = prompt("Enter some HTML code here");
  if (html) {
    editor.insertHTML(html);
  }
}
function highlight() {
  editor.surroundHTML('<span style="background-color: yellow">', '</span>');
}
