<?php
if(!class_exists('Wiki'))
    require_once dirname(__FILE__).'/Wiki.php';
if(!class_exists('Wiki_DB'))
    require_once dirname(__FILE__).'/Wiki_DB.php';

// Fields in the DB
@define('WK_USER_FIELD_ID','utilisateurs_id');
@define('WK_USER_FIELD_NAME','utilisateurs_nom');
@define('WK_USER_FIELD_PASS','utilisateurs_mdp');
@define('WK_USER_FIELD_COLOR','utilisateurs_couleur');
@define('WK_USER_FIELD_SIGNATURE','utilisateurs_signature');

@define('WK_USER_EXISTS',1);
@define('WK_USER_NOT_EXISTS',2);
@define('WK_USER_BAD_PASS',3);

class Wiki_User {
    var $id = false;
    var $name = '';
    var $password = '';
    var $color = 'ffffff';
    var $signature = '';
    
    /**
     * Constructor PHP 4
     * Call the <code>__construct</code> method.
     * View <code>__construct</code> method for details.
     */
    function Wiki_User($user_id) { $this->__construct($user_id);}
    /**
     * Constructor PHP 5
     */
    function __construct($user_id=false)
    {
        if($user_id !== false) {
            $db = Wiki_DB::getInstance();
            $query_user_by_id = "SELECT * FROM `".Wiki::getConfig('table_utilisateurs')."` ".
                                "WHERE ".WK_USER_FIELD_ID."='".$user_id."';";
            $users = $db->query($query_user_id);
            if(!empty($users))
                $this->populate($users[0]);
        }
    }
    
    function &findByUserName($user_name='')
    {
        $db = Wiki_DB::getInstance();
        $query_user_by_name = "SELECT * FROM `".Wiki::getConfig('table_utilisateurs')."` ".
                              "WHERE ".WK_USER_FIELD_NAME."='".$user_name."';";
        $users = $db->query($query_user_by_name);
        if(empty($users))
            return false;
        else {
            $u = new Wiki_User();
            $u->populate($users[0]);
            return $u;
        }
    }
    
    function authenticate($user_password='')
    {
        if($this->id === false)
            return false;
        return ($this->password == $user_password);
    }
    function populate($user_infos = array())
    {
        $this->id       = isset($user_infos[WK_USER_FIELD_ID])    ? $user_infos[WK_USER_FIELD_ID] : '';
        $this->name     = isset($user_infos[WK_USER_FIELD_NAME])  ? $user_infos[WK_USER_FIELD_NAME] : '';
        $this->password = isset($user_infos[WK_USER_FIELD_PASS])  ? $user_infos[WK_USER_FIELD_PASS] : '';
        $this->color    = isset($user_infos[WK_USER_FIELD_COLOR]) ? $user_infos[WK_USER_FIELD_COLOR] : '';
        //$this->signature = $user_infos[WK_USER_FIELD_SIGNATURE];
    }
    
    function insert()
    {
        if($this->id !== false)
            return false;
        
        $db = Wiki_DB::getInstance();
        $u = Wiki_User::findByUserName($this->name);
        if($u !== false) {
            return WK_USER_EXISTS;
        }
        unset($u);
        $query_user_insert = "INSERT INTO `".Wiki::getConfig('table_utilisateurs')."`
                              (".WK_USER_FIELD_NAME.", ".WK_USER_FIELD_PASS.", ".WK_USER_FIELD_COLOR.")
                              VALUES('".$db->escape_string($this->name)."',
                                     '".$db->escape_string($this->password)."',
                                     '".$db->escape_string($this->color)."');
                              ";
        if($db->execute($query_user_insert)) {
            $this->id = $db->get_last_id();
            return true;
        }
        else
            return false;
    }
    function update()
    {
        if($this->id === false)
            return false;
        $db = Wiki_DB::getInstance();
        $query_user_update = "UPDATE `".Wiki::getConfig('table_utilisateurs')."`
                              SET ".WK_USER_FIELD_NAME." = '".$db->escape_string($this->name)."', 
                                  ".WK_USER_FIELD_PASS." = '".$db->escape_string($this->password)."', 
                                  ".WK_USER_FIELD_COLOR." = '".$db->escape_string($this->color)."'
                              WHERE ".WK_USER_FIELD_ID." = '".$this->id."';
                              ";
        echo $query_user_update;
        return $db->execute($query_user_update);
    }
    function delete()
    {
        if($this->id === false)
            return false;

    }
}
/* // standalone testing
include '../wk_config.php';
// create a user
$user = new Wiki_User();
$user->name = 'my_name';
$user->password = 'my_pass';
$user->color = 'my_color';
$res_insert = $user->insert();
var_dump($res_insert);
echo '<br />';
unset($user);
// search a user
$user = Wiki_User::findByUserName('my_name');
var_dump($user);
echo '<br />';
var_dump($user->authenticate('my_pass'));
unset($user);
// update an user
$user = Wiki_User::findByUserName('my_name');
$user->color = '987654';
echo '<br />';
var_dump($user->update());
//*/
?>
