<?php
if(function_exists('error_reporting'))
    @error_reporting(E_ALL);

require_once '../lib/Wiki_DB.php';
require_once '../lib/Wiki.php';
require_once '../compat.php';
define('WK_VERSION','4 alpha');
define('WK_SYSTEM_DIR','_wk');

// Detecting Path of the wiki and HTTP Path
$current_path = str_replace("\\","/",__FILE__);
$wkPath = substr($current_path,0,strpos($current_path,WK_SYSTEM_DIR.'/'));
define('WK_PATH',$wkPath);
$current_url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'];
$wkHTTPPath = substr($current_url,0,strpos($current_url,WK_SYSTEM_DIR.'/'));
define('WK_HTTPPATH',$wkHTTPPath);

//echo WK_PATH;
//echo WK_HTTPPATH;

// Attempt to load older config file
if(@is_file('../wk_config.php')){
    require_once '../wk_config.php';
   // include_once '../wk_identification_admin.php';
    require_once 'configuration_compat.php';
    @define('WK_INSTALLED',true); // already installed, update process
}
else{
    // not previously installed
    @define('WK_INSTALLED',false);
}

// defining the language used
if(isset($_POST['lang']))
    $WK['lang'] = $_POST['lang'];
elseif(isset($_GET['lang']))
    $WK['lang'] = $_GET['lang'];
elseif(!isset($WK['lang']))
    $WK['lang'] = 'fr';

$file_lang = dirname(__FILE__).'/lang/'.$WK['lang'].'.php';


if(!@is_file($file_lang)){ // language not available
    $WK['lang'] = 'fr'; // use default french
    require_once dirname(__FILE__).'/lang/'.$WK['lang'].'.php';
}
else // retrieves language defs
    require_once $file_lang;

require_once 'setup.functions.inc.php';


if (!isset($_POST['installAction'])) {
    $_POST['installAction'] = '';
}

if(WK_INSTALLED === true) {
    $page_title = WK_CONF_TITLE_UPDATE;
}
else
    $page_title = WK_CONF_TITLE_INSTALL;

switch ($_POST['installAction']) {
    case 'check':
        $page_content = '';
        $WK = $_POST;
        // Checking the configuration parameters
        $check_res = setup_checkConfiguration();
        if (is_array($check_res)) { //errors
            $page_content.= WK_CONF_ERRORS_CONF . '<br /><br />';
            $page_content.= '<span style="color: #FF0000">- ' . implode('<br />- ', $check_res) . '</span><br /><br />';
            $page_content.= setup_sprintConfigTemplate(setup_parseTemplate(dirname(__FILE__).'/installation_page.tpl.php'), $_POST, true);
            break;
        }  
        // configuration seems ok
        
        // Installing the database
        $install_db_res = setup_installDatabase();
        if (is_array($install_db_res)) {
            $page_content.= WK_CONF_ERRORS_INSTALL . '<br /><br />';
            $page_content.= '<span style="color: #FF0000">- ' . implode('<br />', $install_db_res) . '</span><br /><br />';
            $page_content.= setup_sprintConfigTemplate(setup_parseTemplate(dirname(__FILE__).'/installation_page.tpl.php'), $_POST, true);
            break;
        }
        if($install_db_res === false) {
            $page_content.= WK_CONF_ERRORS_INSTALL . '<br /><br />';
            $page_content.= '<span style="color: #FF0000">- ' . WK_CONF_ERR_DB_INSTALL . '</span><br /><br />';
            break;
        }
        else {
            if(DB_ALREADY_INSTALLED == true)
                $page_content.= sprintf(WK_CONF_DB_ALREADY_INSTALLED,$_POST['dbName']).'<br/>';
            else
                $page_content.= sprintf(WK_CONF_DB_INSTALLED,$_POST['dbName']).'<br/>';
        }
        // database installed
        
        // Writing the Configuration
        $write_conf_res = setup_updateConfiguration();
        if (is_array($write_conf_res)) {
            $page_content.= WK_CONF_ERRORS_INSTALL . '<br /><br />';
            $page_content.= '<span style="color: #FF0000">- ' . implode('<br />', $write_conf_res) . '</span><br /><br />';
            $page_content.= setup_sprintConfigTemplate(setup_parseTemplate(dirname(__FILE__).'/installation_page.tpl.php'), $_POST, true);
          
            break;
        }
        
        $page_content.= WK_CONF_UPDATED.'<br/><br/>';
        // configuration updated
        $page_content.= sprintf(WK_CONF_SAVED_SUCCESSFUL,WK_HTTPPATH.'index.html',$_POST['adminLogin'],$_POST['adminPass']).'<br/><br/>';
        
        
        // Attempt to write the home page file
        // if wikiwig was not not previously installed
        if(WK_INSTALLED === false || !@is_file(WK_PATH.'index.html')) {
            //echo WK_PATH.'index.html';
            
            if($fp = @fopen(WK_PATH.'index.html','w+')){
                $homepage_html = implode('',file('../template/system/wk_basic_page.tpl'));
                // prepare the template special strings
                $homepage_html = str_replace('<title>{head_title}</title>','<title>{wkName}</title>',$homepage_html);
                $homepage_html = str_replace('<h1>{content_title}</h1>','<h1>{wkName}</h1>',$homepage_html);
                
                // Replace template strings with global configured vars
                foreach($_POST as $k => $v){
                    $homepage_html = str_replace('{'.$k.'}',$v,$homepage_html);
                }
                $systemDirHTTPPath = WK_HTTPPATH.WK_SYSTEM_DIR.'/';
                $homepage_html = str_replace('{CSS_HTTP_PATH}',$systemDirHTTPPath.$WK['css_wiki'],$homepage_html);
                $homepage_html = str_replace('{JS_HTTP_PATH}',$systemDirHTTPPath.'wk_dyn_pages.php?js',$homepage_html);
                $homepage_html = str_replace('{MAP}',MAP,$homepage_html);
                $homepage_html = str_replace('{MAP_LINK}',$systemDirHTTPPath.'/wk_liste.php',$homepage_html);
                $homepage_html = str_replace('{content}',HOMEPAGE_CONTENT,$homepage_html);
                fwrite($fp,$homepage_html);
                fclose($fp);
            }
        }
        else {
            // indicates to the user that he should launch the parsing of the wiki
            $page_content.= '<strong>'.sprintf(WK_CONF_UPGRADE_MSG,'../wk_admin.php','../wk_admin.php?action=parseall').'</strong><br/><br/>';
        }
        
        /* // older version using wk_local.php files
        // create root dir properties file
        require_once '../lib/Wiki.php';
        Wiki::setFolderProperties(WK_PATH,WK_PATH);
        */
        $page_content.= WK_Mail;
         break;
       

    default:
        /*  Is wikiwig already installed=  */
        if (WK_INSTALLED === true) {
            $from = &$WK;
        } else {
            $from = false;
        }
        $page_content = setup_parseTemplate(dirname(__FILE__).'/installation_page.tpl.php');
        
        /* COMMENTAIRE 
        *  janvier 2006
        *	 si l'admin est dj enregistr dans la base il faut aller le chercher
        *  et le remplasser dans l'affichage du config
        *  sinon, laisser la config comme avant.
        */
				$db=Wiki_DB::getInstance();
	   		$requete="SELECT * FROM ".Wiki::getConfig('table_utilisateurs')." WHERE utilisateurs_nom LIKE '%admin_%'";
	   		//$res=$db->query($requete);
	   		if ($res!=0){
	   			$admin = split('admin_', $res[0]['utilisateurs_nom']);
        //$page_content['categories']['WK_CONF_GENERAL']['6']['default'] = "hahaha";
      	
     
      		for ($i = 0; $i <=sizeof($page_content['categories']['WK_CONF_GENERAL']); $i++){
         		
	      		$name = $page_content['categories']['WK_CONF_GENERAL'][$i]['name'];
	        	
	      		if ($name=="adminLogin"){ //affichage du nom de l'admin
	       			$page_content['categories']['WK_CONF_GENERAL'][$i++]['default']=$admin[1];
      				//echo "adminLogin<br/>";
	       			}
      			if ($name=="adminPass"){//affichage du mdp de l'admin
	       			$page_content['categories']['WK_CONF_GENERAL'][$i++]['default']=$res[0]['utilisateurs_mdp'];
      				//echo "adminPass<br/>";
	       		}
      			if ($name=="adminMail"){//affichage du mail de l'admin
	       			$page_content['categories']['WK_CONF_GENERAL'][$i++]['default']=$res[0]['utilisateurs_couleur'];
      				//echo "adminMail<br/>";
	       		}
	    	
	    	}
	    	$page_content = setup_sprintConfigTemplate($page_content, $from);
    	}
    	else{
    	 $page_content = setup_sprintConfigTemplate(setup_parseTemplate(dirname(__FILE__).'/installation_page.tpl.php'), $from);
  	}
}

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        <title><?php echo WK_CONF_TITLE; ?></title>
        <link href="../wk_style.css" rel="stylesheet" type="text/css" />

    </head>

    <body class="actions">
           <div id="header"><?php echo WK_CONF_TITLE; ?></div>
        <div id="results">
            <span class="errors">
                 
            </span>
            <span class="message">
                 
            </span>
        </div>
        <div id="content">
            <h1><?php echo $page_title; ?></h1>
            <?php echo(print_r($page_content)); ?> 
        </div>
        <?php if(empty($_POST['installAction'])) {?>
        <div id="flags" style="position:absolute;right:50px;top:60px;">
            <a href="?lang=fr" title="Version Fran&ccedil;aise"><img src="../images/flag-french.gif" alt="Version Fran&ccedil;aise" /></a>
            <a href="?lang=en" title="English Version"><img src="../images/flag-english.gif" alt="English Version" /></a>
        </div>
        <?php }
        ?> 
        <div style="position:absolute;right:30px;top:30px;">
            <a href="../wk_admin.php"><?php echo WK_CONF_LABEL_LINK_ADMIN; ?></a>&nbsp;|&nbsp;<a href='../../index.html'><?php echo WK_CONF_LABEL_GO_WIKI; ?></a>
        </div>
    </body>
</html>